## msxpertsuite 5.8.6

=== CMakeLists.txt ===
#############################################################
# CMake configuration
cmake_minimum_required(VERSION 3.0)

# Add folder where are supportive functions
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/CMakeStuff)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

# This export will allow using the flags to be used by
# youcompleteme (vim plugin).
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

# We want C++11
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
# deprecated, cmake does the job: ADD_DEFINITIONS(-std=c++11)

# We do not want warnings for unknown pragmas:
ADD_DEFINITIONS(-Wno-unknown-pragmas)

# Include the various colors we want to use in the output
include(outputColors)

# Include the system's uname that fills in SYSTEM_UNAME_S.
# Sets WIN64 if SYSTEM_UNAME_S is "^.*MING64.*"
include(systemUname)


############################################################
# Basic information about project

project(msXpertSuite)
set(VERSION 5.8.6)


# Set additional project information
set(COMPANY "msXpertSuite.org")
set(COPYRIGHT "Copyright (c) 2008-2018 Filippo Rusconi. Licensed under GPLv3+")
set(IDENTIFIER "org.msxpertsuite")


message("")
message(STATUS "${BoldGreen}Starting configuration of msXpertSuite${ColourReset}")
message(STATUS "${BoldYellow}System is detected by CMake as ${SYSTEM_UNAME_S}${ColourReset}")
message("")


# No need to specify position independent code flag on MING64_NT
# because that flag is set automatically and it triggers an error when -Werror
# is set.
if(NOT WIN64)
	ADD_DEFINITIONS(-fPIC)
endif()

if(APPLE)
	add_definitions("-DAPPLE=1")
	add_definitions("-stdlib=libc++")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
	message(STATUS "using ${CMAKE_CXX_FLAGS}")
endif()

########################################################
# Source tree preparation
# On windows and mac, some libraries are added to the source tree
# while on Debian GNU/Linux there libraries are packaged.
########################################################

if(APPLE OR WIN64)

	message(STATUS "should copy the qcustomplot directory.")

	# This include must come before all the others
	# It must include the config-generated config.h file
	# before the others.
	include_directories(${CMAKE_BINARY_DIR})

	# Copy the qcustomplot directory to the source tree
	execute_process(COMMAND cp -vrp ${CMAKE_SOURCE_DIR}/../helper-libs/qcustomplot
		${CMAKE_SOURCE_DIR}
		WORKING_DIRECTORY	${CMAKE_SOURCE_DIR})

	set(QCUSTOMPLOT_SRC_DIR ${CMAKE_SOURCE_DIR}/qcustomplot)
	include_directories(${QCUSTOMPLOT_SRC_DIR})

	# Copy the tclap directory to the source tree
	message(STATUS "should copy the tclap directory.")

	execute_process(COMMAND cp -vrp ${CMAKE_SOURCE_DIR}/../helper-libs/tclap
		${CMAKE_SOURCE_DIR}
		WORKING_DIRECTORY	${CMAKE_SOURCE_DIR})

	set(TCLAP_SRC_DIR ${CMAKE_SOURCE_DIR}/tclap)
	include_directories(${CMAKE_SOURCE_DIR})

	# Copy the isospec directory to the source tree
	message(STATUS "should copy the isospec directory.")

	execute_process(COMMAND cp -vrp ${CMAKE_SOURCE_DIR}/../helper-libs/isospec
		${CMAKE_SOURCE_DIR}
		WORKING_DIRECTORY	${CMAKE_SOURCE_DIR})

	set(ISOSPEC_SRC_DIR ${CMAKE_SOURCE_DIR}/isospec)
	include_directories(${CMAKE_SOURCE_DIR})

endif()



#############################################################
# On MINGW.* we provide a number of libraries by our own, that we
# put mingw64/usr/local/lib
if(WIN64)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -L/mingw64/usr/local/lib")
endif()


#############################################################
# Enable warnings and possibly treat them as errors
add_definitions(-Wall)

if(WARNASERR)
	message(STATUS "${BoldYellow}Warnings treated as errors.${ColourReset}")
	add_definitions(-Werror)
endif()

# On MINGW64_NT, we want to build as release, otherwise build as debug.
if(WIN64)
	set(CMAKE_BUILD_TYPE "release")
	add_definitions(-DQT_NO_DEBUG)
else()
	if(NOT CMAKE_BUILD_TYPE STREQUAL "release")
		set(CMAKE_BUILD_TYPE "debug")
	endif()
endif()

# But the user may want something easier to set: -DDEBUG
if(DEBUG)
	set(CMAKE_BUILD_TYPE "debug")
endif()

if(CMAKE_BUILD_TYPE STREQUAL "debug")
	add_definitions(-g -O0)
	message(STATUS "${BoldYellow}Debug support requested. Adding -g -O0.${ColourReset}")
else()
	add_definitions(-O3)
	message(STATUS "${BoldYellow}Debug support NOT requested. Adding -O3.${ColourReset}")
endif()

if(APPLE)
	link_directories("/opt/local/lib")
endif()

if(OPENMP)
	message(STATUS "${BoldYellow}OpenMP support is requested, adding -fopenmp flag.${ColourReset}")
	if(APPLE)
		include_directories("/opt/local/include/libomp")
		link_directories("/opt/local/lib/libomp")
	else()
		add_definitions(-fopenmp)
	endif()

	# Depending on the compiler, if we need the omp.h header file,
	# we'll have to look for it in different locations.

	message(STATUS "${BoldRed}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")
	message(STATUS "${BoldRed}CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}${ColourReset}")

	if(CMAKE_CXX_COMPILER MATCHES ".*clang.*")
		message(STATUS "${BoldRed}Using clang++${ColourReset}")
		include_directories("${CMAKE_SOURCE_DIR}/clang-openmp")
		link_directories("${CMAKE_SOURCE_DIR}/clang-openmp")
		set(OPENMP_LIBRARY omp)
	else()
		message(STATUS "${BoldRed}Not using clang++${ColourReset}")
		set(OPENMP_LIBRARY gomp)
	endif()

	message(STATUS "${BoldYellow}Using parallelizing library ${OPENMP_LIBRARY}${ColourReset}")
endif()

if(PROFILE)
	message(STATUS "${BoldYellow}Profiling is requested, adding -pg flag.${ColourReset}")
	add_definitions(-pg)
endif()


message(STATUS "${BoldYellow}Main CMAKE_BINARY_DIR: ${CMAKE_BINARY_DIR}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

# For the config.h file.
set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_subdirectory(globals)
add_subdirectory(libmass)
add_subdirectory(libmassgui)

# It is essential to run these config steps before delving into the massxpert
# and minexpert directories, because at that moment they will need what are
# going to prepare right now.
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/splashscreen.svg.in
	${CMAKE_SOURCE_DIR}/images/splashscreen.svg @ONLY)

CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/msxpertsuite-mingw64-win7+.iss.in
	${CMAKE_SOURCE_DIR}/winInstaller/msxpertsuite-mingw64-win7+.iss @ONLY)

# Let's also set the software version in the DocBook entity file so that the
# user manuals show the right version.
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/msxpertsuite-user-manuals.ent.in
	${CMAKE_SOURCE_DIR}/doc/user-manuals/common/msxpertsuite-user-manuals.ent @ONLY)

# Make the conversion of the svg file into a png, but only on GNU/Linux
if(UNIX AND NOT APPLE)
	execute_process(COMMAND convert ${CMAKE_SOURCE_DIR}/images/splashscreen.svg
		${CMAKE_SOURCE_DIR}/images/splashscreen.png)
endif()

# In the following subdirectories, we'll set all the install directories, that
# will always be a subdirectory of the CMake-default CMAKE_INSTALL_PREFIX.

############################## MASSXPERT #############################
add_subdirectory(massxpert)

get_directory_property(MASSXPERT_TARGET_NAME
	DIRECTORY massxpert
	MASSXPERT_TARGET_NAME)

get_directory_property(MASSXPERT_BIN_DIR
	DIRECTORY massxpert
	MASSXPERT_BIN_DIR)

get_directory_property(MASSXPERT_JAVASCRIPT_DIR
	DIRECTORY massxpert
	MASSXPERT_JAVASCRIPT_DIR)

get_directory_property(MASSXPERT_DATA_DIR
	DIRECTORY massxpert
	MASSXPERT_DATA_DIR)

get_directory_property(MASSXPERT_DOC_DIR
	DIRECTORY massxpert
	MASSXPERT_DOC_DIR)

############################## MINEXPERT #############################
add_subdirectory(minexpert)

get_directory_property(MINEXPERT_TARGET_NAME
	DIRECTORY minexpert
	MINEXPERT_TARGET_NAME)

get_directory_property(MINEXPERT_BIN_DIR
	DIRECTORY minexpert
	MINEXPERT_BIN_DIR)

get_directory_property(MINEXPERT_JAVASCRIPT_DIR
	DIRECTORY minexpert
	MINEXPERT_JAVASCRIPT_DIR)

get_directory_property(MINEXPERT_DATA_DIR
	DIRECTORY minexpert
	MINEXPERT_DATA_DIR)

get_directory_property(MINEXPERT_DOC_DIR
	DIRECTORY minexpert
	MINEXPERT_DOC_DIR)

# Use all the configured paths to create the config.h file.
# The config.h file is generated in the CMAKE_BINARY_DIR!!!
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/config.h.in
	config.h @ONLY)

add_subdirectory(doc)

if(DEVDOC)
	add_subdirectory(devdoc)
endif()

if(TESTS)
	add_subdirectory(tests)
endif()

#############################################################
# summary
message("")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message(STATUS "${BoldRed} General configuration of the msXpertSuite project ${ColourReset}")
message("")
message(STATUS "${BoldYellow}The system is detected by CMake as ${SYSTEM_UNAME_S}${ColourReset}")
message("")
message(STATUS "${BoldYellow}CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}${ColourReset}")
message("")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~~~ massXpert ~~~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~~~ massXpert ~~~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message(STATUS "${BoldYellow}MASSXPERT_BIN_DIR: ${MASSXPERT_BIN_DIR}${ColourReset}")
message(STATUS "${BoldYellow}MASSXPERT_JAVASCRIPT_DIR: ${MASSXPERT_JAVASCRIPT_DIR}${ColourReset}")
message(STATUS "${BoldYellow}MASSXPERT_DATA_DIR: ${MASSXPERT_DATA_DIR}${ColourReset}")
message(STATUS "${BoldYellow}MASSXPERT_DOC_DIR: ${MASSXPERT_DOC_DIR}${ColourReset}")
message("")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~~~ mineXpert ~~~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~~~ mineXpert ~~~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message(STATUS "${BoldYellow}MINEXPERT_BIN_DIR: ${MINEXPERT_BIN_DIR}${ColourReset}")
message(STATUS "${BoldYellow}MINEXPERT_JAVASCRIPT_DIR ${MINEXPERT_JAVASCRIPT_DIR}${ColourReset}")
message(STATUS "${BoldYellow}MINEXPERT_DATA_DIR: ${MINEXPERT_DATA_DIR}${ColourReset}")
message(STATUS "${BoldYellow}MINEXPERT_DOC_DIR: ${MINEXPERT_DOC_DIR}${ColourReset}")
message("")
if(PROFILE)
	message(STATUS "${BoldYellow}Profiling is requested (-DPROFILE=1)${ColourReset}")
else()
	message(STATUS "${BoldYellow}Profiling is NOT requested (-DPROFILE=0)${ColourReset}")
endif()
message("")
if(OPENMP)
	message(STATUS "${BoldYellow}OpenMP support is requested (-DOPENMP=1)${ColourReset}")
else()
	message(STATUS "${BoldYellow}OpenMP support is NOT requested (-DOPENMP=0)${ColourReset}")
endif()
message("")
if(WARNASERR)
	message(STATUS "${BoldYellow}Warnings treated as errors (-DWARNASERR=1)${ColourReset}")
else()
	message(STATUS "${BoldYellow}Warnings NOT treated as errors (-DWARNASERR=0)${ColourReset}")
endif()
message("")
if(CMAKE_BUILD_TYPE STREQUAL "debug")
	message(STATUS "${BoldYellow}Debug support requested (-DDEBUG=1)${ColourReset}")
else()
	message(STATUS "${BoldYellow}Debug support NOT requested (-DDEBUG=0)${ColourReset}")
endif()
message("")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")
message("")
message(STATUS "${BoldYellow}You can ask for clang++ by issuing the following command: $CXX=clang++ cmake -DOPENMP=1 -DDEBUG=1 ../development/${ColourReset}")
message(STATUS "${BoldYellow}The typical cmake invocation on mingw64 would be: cmake -DDEBUG=0 -DOPENMP=1 ../development/ -G'Unix Makefiles' -DCMAKE_CXX_COMPILER=/mingw64/bin/x86_64-w64-mingw32-g++.exe ${ColourReset}")
message(STATUS "${BoldYellow}The typical cmake invocation on Debian GNU/Linux would be: $cmake -DOPENMP=1 -DDEBUG=1 ../development${ColourReset}")
message("")
message(STATUS "${BoldYellow}The typical DeveloperMode cmake invocation on Debian GNU/Linux would be: $cmake -DOPENMP=1 -DDEBUG=1 -DDEVMODE=1 -DBUILD_USER_MANUALS=1 ../development${ColourReset}")
message("")

=== libmassgui/CMakeLists.txt ===
# Get the name of the current directory but with no path:
get_filename_component(TARGET ${CMAKE_CURRENT_BINARY_DIR} NAME)

message("")
message(STATUS "${BoldGreen}Start processing ${TARGET} dir.${ColourReset}")
message("")


########################################################
# Files

file(GLOB massgui_SRCS *.cpp)
file(GLOB massgui_UIS ui/*.ui)
file(GLOB Resources *.qrc)

# On MINGW, the QCustomPlot files are added to the project,
# while on GNU/Linux, there is a library. See main CMakeLists.txt.
if(APPLE OR (SYSTEM_UNAME_S MATCHES "^MINGW.*"))

	file(GLOB ${TARGET}_qcustomplot_SRC ${QCUSTOMPLOT_SRC_DIR}/*.cpp)

endif()


set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

find_package(Qt5 COMPONENTS Widgets Xml Svg Sql Script)

qt5_wrap_ui(massgui_UIS_H ${massgui_UIS})

### CMake now only automocs the generated files and not the source files.
set_source_files_properties(${massgui_UIS_H} PROPERTIES SKIP_AUTOMOC ON)


###############################################################
# Configuration of the binary to be built
###############################################################

add_library(massgui STATIC 
	${massgui_SRCS}
	${massgui_UIS_H}
	${glob_SRCS}
	${${TARGET}_qcustomplot_SRC}
	)


qt5_use_modules(massgui Widgets)
qt5_use_modules(massgui Xml)
qt5_use_modules(massgui Svg)
qt5_use_modules(massgui Sql)
qt5_use_modules(massgui Script)
qt5_use_modules(massgui PrintSupport)

include_directories(
	# For the config.h file generated from config.h.in	
	${CMAKE_BINARY_DIR}

	# For all the source subdirectories
	${CMAKE_SOURCE_DIR}

	# For the ui_Xyyyyy.h files
	${CMAKE_CURRENT_BINARY_DIR} 

	${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_CURRENT_BINARY_DIR}


	${Qt5Widgets_INCLUDE_DIRS}
	${Qt5Xml_INCLUDE_DIRS}
	${Qt5Svg_INCLUDE_DIRS}
	${Qt5Sql_INCLUDE_DIRS}
	${Qt5Script_INCLUDE_DIRS}
	${Qt5PrintSupport_INCLUDE_DIRS})


# On GNU/Linux, make sure we have the QCustomPlot library
# installed on the system (on MINGW, we have the
# source files (see above).
if((NOT SYSTEM_UNAME_S MATCHES "^MINGW.*") AND
	(NOT SYSTEM_UNAME_S MATCHES "Darwin"))

	find_package(QCustomPlot)

	if(NOT QCustomPlot_FOUND)
		message(FATAL_ERROR "QCustomPlot not found!")
	else()
		message(STATUS "QCustomPlot found!")
	endif()

endif()

if(APPLE)
	set(MASSLIB "${CMAKE_BINARY_DIR}/libmass/libmass.a")
else()
	set(MASSLIB "-Wl,-whole-archive ${CMAKE_BINARY_DIR}/libmass/libmass.a -Wl,-no-whole-archive")
endif()

# Use the Widgets module from Qt 5 and the libmass. We craft a variable for this
# so as to transmit it directly to the tests subdirectory that will need it.

set(required_target_link_libraries 
	${MASSLIB} 
	Qt5::Widgets 
	Qt5::Xml 
	Qt5::Svg 
	Qt5::Sql 
	Qt5::Script
	Qt5::PrintSupport)

# When in UNIX but not APPLE, we can make use the system-wide qcustomplot library.
if(UNIX AND NOT APPLE)
	set(required_target_link_libraries
		${required_target_link_libraries}
		"qcustomplot")
endif()

# on MINGW.*, we'll need to add the -lstdc++ flag. Don't ask why.
if(SYSTEM_UNAME_S MATCHES "^MINGW.*")
	set(required_target_link_libraries
		${required_target_link_libraries}
		"stdc++")
endif()


#### Debugging stuff
#message(STATUS required_target_link_libraries: ${required_target_link_libraries})
#get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
#foreach(dir ${dirs})
#message(STATUS "included dir='${dir}'")
#endforeach()


# Finally actually set the liking dependencies to the library.
target_link_libraries(massgui
	${required_target_link_libraries})


message(STATUS "${TARGET} CMAKE_CURRENT_BINARY_DIR: ${CMAKE_CURRENT_BINARY_DIR}")
message(STATUS "Qt5Widgets: " ${Qt5Widgets_INCLUDE_DIRS})
message(STATUS "Qt5Xml: " ${Qt5Xml_INCLUDE_DIRS})
message(STATUS "Qt5Svg: " ${Qt5Svg_INCLUDE_DIRS})
message(STATUS "Qt5Sql: " ${Qt5Sql_INCLUDE_DIRS})
message(STATUS "Qt5Script: " ${Qt5Script_INCLUDE_DIRS})
message(STATUS "Qt5PrintSupport: " ${Qt5PrintSupport_INCLUDE_DIRS}) 
if(PROFILE)
	message(STATUS "Profiling is requested, adding linker -pg flag.")
endif()


message("")
message(STATUS "${BoldGreen}Finished processing ${TARGET} dir.${ColourReset}")
message("")

=== massxpert/CMakeLists.txt ===
set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

if(APPLE)
	set(TARGET massXpert)
	message(STATUS "APPLE target name: ${TARGET}")
elseif(UNIX AND NOT APPLE)
	set(TARGET massxpert)
	message(STATUS "NON-APPLE target name: ${TARGET}")
elseif(WIN64)
	set(TARGET massXpert)
	message(STATUS "WIN64: ${TARGET}")
endif()

message("")
message(STATUS "${BoldGreen}Starting configuring of the ${TARGET} submodule${ColourReset}")
message("")

#############################################################
# Software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

########################################################
# Files
file(GLOB MASSXPERT_nongui_SRCS nongui/*.cpp)
file(GLOB MASSXPERT_gui_SRCS gui/*.cpp)
file(GLOB MASSXPERT_SRCS *.cpp)
file(GLOB MASSXPERT_UIS gui/ui/*.ui)

# The desktop file
if(UNIX AND NOT APPLE)
	install(FILES org.msxpertsuite.massxpert.desktop
		DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications)
	install(FILES org.msxpertsuite.massxpert.appdata.xml
		DESTINATION ${CMAKE_INSTALL_PREFIX}/share/metainfo)

endif()

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

find_package(Qt5 COMPONENTS Widgets Xml Svg Sql Script)

qt5_wrap_ui(MASSXPERT_UIS_H ${MASSXPERT_UIS})

qt5_add_resources(MASSXPERT_QRC_CPP gui/application.qrc)

### These two lines required because now CMake only automocs
### the generated files and not the source files.
set_source_files_properties(${MASSXPERT_UIS_H} PROPERTIES SKIP_AUTOMOC ON)
set_source_files_properties(${MASSXPERT_QRC_CPP} PROPERTIES SKIP_AUTOMOC ON)


###############################################################
# Configuration of the binary to be built
###############################################################

if(NOT APPLE)
	add_executable(${TARGET}
		${MASSXPERT_nongui_SRCS}
		${MASSXPERT_gui_SRCS}
		${MASSXPERT_SRCS}
		${MASSXPERT_UIS_H}
		${MASSXPERT_QRC_CPP})
else()

	# Copy the icon file to the Contents/Resources directory of the bundle at
	# location ${MACOSX_PACKAGE_LOCATION}.
	set_source_files_properties(../images/msXpertSuite.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)

	# Identify MacOS bundle

	set(MACOSX_BUNDLE_BUNDLE_NAME ${TARGET})
	message(STATUS "MACOSX_BUNDLE_BUNDLE_NAME: ${MACOSX_BUNDLE_BUNDLE_NAME}")

	set(MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_LONG_VERSION_STRING ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_COPYRIGHT ${COPYRIGHT})
	set(MACOSX_BUNDLE_GUI_IDENTIFIER ${IDENTIFIER})
	set(MACOSX_BUNDLE_ICON_FILE ../images/msXpertSuite.icns)

	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mmacosx-version-min=10.9"
		CACHE STRING "Flags used by the compiler during all build types." FORCE)

	#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden"
	#CACHE STRING "Flags used by the compiler during all build types." FORCE)

	set(CMAKE_OSX_SYSROOT "/Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.12.sdk/"
		CACHE STRING "MacOSX10.12.sdk." FORCE)

	add_executable(${TARGET} MACOSX_BUNDLE
		${MASSXPERT_nongui_SRCS}
		${MASSXPERT_gui_SRCS}
		${MASSXPERT_SRCS}
		${MASSXPERT_UIS_H}
		${MASSXPERT_QRC_CPP}
		../images/msXpertSuite.icns
		)

	set_target_properties(${TARGET} PROPERTIES MACOSX_BUNDLE_ICON_FILE msXpertSuite.icns)

endif()


###############################################################
# Installation directories depending on the platform and module
###############################################################

if(WIN64)
	set(CMAKE_INSTALL_PREFIX "C:/Program Files/msXpertSuite")
	set(MASSXPERT_BIN_DIR ${CMAKE_INSTALL_PREFIX})
	set(MASSXPERT_JAVASCRIPT_DIR ${CMAKE_INSTALL_PREFIX}/javascript/massxpert)
	set(MASSXPERT_DATA_DIR ${CMAKE_INSTALL_PREFIX}/data/massxpert)
	set(MASSXPERT_DOC_DIR ${CMAKE_INSTALL_PREFIX}/doc/massxpert)
elseif(UNIX AND NOT APPLE)
	set(MASSXPERT_BIN_DIR ${CMAKE_INSTALL_PREFIX}/bin)
	set(MASSXPERT_JAVASCRIPT_DIR ${CMAKE_INSTALL_PREFIX}/share/msxpertsuite-massxpert/javascript)
	set(MASSXPERT_DATA_DIR ${CMAKE_INSTALL_PREFIX}/share/msxpertsuite-massxpert/data)
	set(MASSXPERT_DOC_DIR ${CMAKE_INSTALL_PREFIX}/share/msxpertsuite-massxpert/doc)
elseif(APPLE)
	SET (BUNDLE_DIR ${CMAKE_CURRENT_BINARY_DIR}/massXpert.app)
	SET(CMAKE_INSTALL_PREFIX "${BUNDLE_DIR}/Contents")
	SET (MASSXPERT_BIN_DIR ${BUNDLE_DIR}/Contents/MacOS)
	SET (MASSXPERT_JAVASCRIPT_DIR ${BUNDLE_DIR}/Contents/Resources/massxpert/javascript)
	SET (MASSXPERT_DATA_DIR ${BUNDLE_DIR}/Contents/Resources/massxpert/data)
	SET (MASSXPERT_DOC_DIR ${BUNDLE_DIR}/Contents/Resources/massxpert/doc)
endif()

message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "MASSXPERT_BIN_DIR: ${MASSXPERT_BIN_DIR}")
message(STATUS "MASSXPERT_JAVASCRIPT_DIR: ${MASSXPERT_JAVASCRIPT_DIR}")
message(STATUS "MASSXPERT_DATA_DIR: ${MASSXPERT_DATA_DIR}")
message(STATUS "MASSXPERT_DOC_DIR: ${MASSXPERT_DOC_DIR}")

# Prepare various directory names for the parent directory to use later.
set_directory_properties(PROPERTIES CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
set_directory_properties(PROPERTIES MASSXPERT_TARGET_NAME ${TARGET})
set_directory_properties(PROPERTIES MASSXPERT_BIN_DIR ${MASSXPERT_BIN_DIR})
set_directory_properties(PROPERTIES MASSXPERT_JAVASCRIPT_DIR ${MASSXPERT_JAVASCRIPT_DIR})
set_directory_properties(PROPERTIES MASSXPERT_DATA_DIR ${MASSXPERT_DATA_DIR})
set_directory_properties(PROPERTIES MASSXPERT_DOC_DIR ${MASSXPERT_DOC_DIR})

qt5_use_modules(${TARGET} Widgets)
qt5_use_modules(${TARGET} Xml)
qt5_use_modules(${TARGET} Svg)
qt5_use_modules(${TARGET} Sql)
qt5_use_modules(${TARGET} Script)
qt5_use_modules(${TARGET} PrintSupport)

include_directories(

	# The config file is binary directory-specific !!!
	# For the config.h file generated from config.h.in
	# For the ui_Xyyyyy.h files
	${CMAKE_CURRENT_BINARY_DIR}

	# For all the source subdirectories
	${CMAKE_SOURCE_DIR}

	${CMAKE_BINARY_DIR}/libmassgui

	${Qt5Widgets_INCLUDE_DIRS}
	${Qt5Xml_INCLUDE_DIRS}
	${Qt5Svg_INCLUDE_DIRS}
	${Qt5Sql_INCLUDE_DIRS}
	${Qt5Script_INCLUDE_DIRS}
	${Qt5PrintSupport_INCLUDE_DIRS})


# On GNU/Linux, make sure we have the QCustomPlot library
# installed on the system (on MINGW, we have the
# source files (see above).
if(NOT WIN64 AND NOT APPLE)

	find_package(QCustomPlot)

	if(NOT QCustomPlot_FOUND)
		message(FATAL_ERROR "QCustomPlot not found!")
	else()
		message(STATUS "QCustomPlot found!")
	endif()

endif()

# Now handle the private libraries for non-gui stuff (libmass.a) and gui stuff
# (libmassgui.a)
if(APPLE)

	set(MASSLIB "${CMAKE_BINARY_DIR}/libmass/libmass.a")
	set(MASSGUILIB "${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a")

else()

	set(MASSLIB "-Wl,-whole-archive ${CMAKE_BINARY_DIR}/libmass/libmass.a -Wl,-no-whole-archive")
	set(MASSGUILIB "-Wl,-whole-archive ${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a -Wl,-no-whole-archive")

endif()

message(STATUS "libdir: ${CMAKE_BINARY_DIR}/libmass/libmass.a")
message(STATUS "guilibdir: ${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a")

message(STATUS "Using parallelizing library ${OPENMP_LIBRARY}")

set(required_target_link_libraries
	${MASSLIB}
	${MASSGUILIB}
	${OPENMP_LIBRARY}
	Qt5::Widgets
	Qt5::Xml
	Qt5::Svg
	Qt5::Sql
	Qt5::Script
	Qt5::PrintSupport)


# On WIN64 we provide a number of libraries by our own, that we
# put in /usr/local/lib under /mingw64/.
if(WIN64)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -LC:/msys64/mingw64/usr/local/lib")
endif()


##############################################################
# libpwiz for reading mass spec data files,
message(STATUS "${BoldYellow}Link against the libpwiz library.${ColourReset}")
if(WIN64)
	include_directories("C:/msys64/mingw64/usr/local/include/pwiz")
elseif(APPLE)
	include_directories(/opt/local/include/pwiz)
	link_directories(/opt/local/lib)
else()
	include_directories(/usr/include/proteowizard)
endif()

set(required_target_link_libraries
	${required_target_link_libraries}
	pwiz)


##############################################################
# libIsoSpec++ for calculating isotopic clusters
message(STATUS "${BoldYellow}Link against the libIsoSpec++ library.${ColourReset}")
if(WIN64)
	include_directories("C:/msys64/mingw64/usr/local/include")
elseif(APPLE)
	include_directories("/opt/local/include")
	link_directories("/opt/local/lib")
else()
	include_directories("/usr/include")
endif()

set(required_target_link_libraries
	${required_target_link_libraries}
	IsoSpec++)


##############################################################
# libboost_* on mingw
# On MINGW.* we are our own provider of the boost libraries.
if(WIN64)

	message(STATUS "${BoldYellow}Link against the libboost libraries.${ColourReset}")

	include_directories("${CMAKE_SOURCE_DIR}/../../boost/boost_1_56_0")

	set(required_target_link_libraries
		${required_target_link_libraries}
		boost_chrono
		boost_filesystem
		boost_iostreams
		boost_program_options
		boost_serialization
		boost_system
		boost_thread
		z)

elseif(APPLE)
	# With macport
	include_directories("/opt/local/include")
	link_directories("/opt/local/lib")

	set(required_target_link_libraries
		${required_target_link_libraries}
		boost_chrono-mt
		boost_filesystem-mt
		boost_iostreams-mt
		boost_program_options-mt
		boost_serialization-mt
		boost_system-mt
		boost_thread-mt
		z)

endif()

# On MINGW.*, we'll need to add the -lstdc++ flag. Don't ask why.
if(WIN64)

	set(required_target_link_libraries
		${required_target_link_libraries}
		"stdc++")

endif()

# When on UNIX/NOT APPLE we can make use the system-wide qcustomplot library.
if(UNIX AND NOT APPLE)

	set(required_target_link_libraries
		${required_target_link_libraries}
		"qcustomplot")

endif()


#### Debugging stuff
#message(STATUS required_target_link_libraries: ${required_target_link_libraries})

#message(STATUS "Now printing all the include directories -I...")

#get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
#foreach(dir ${dirs})
#message(STATUS "included dir='${dir}'")
#endforeach()

#message(STATUS "Now printing all the linking directories -L...")

#get_property(dirs DIRECTORY PROPERTY LINK_DIRECTORIES)
#foreach(dir ${dirs})
#message(STATUS "link directory dir='${dir}'")
#endforeach()

# Finally actually set the linking dependencies to the executable.
target_link_libraries(${TARGET}
	${required_target_link_libraries})


# Add an explicit dependency to libmass and libmassgui so that when invoking
# make from inside the massxpert bin build dir, the dependencies get built.
add_dependencies(${TARGET} mass massgui)


if(PROFILE)
	message(STATUS "Profiling is requested, adding linker -pg flag.")
	set (CMAKE_EXE_LINKER_FLAGS "-pg")
endif()


if(NOT APPLE)
	# We want to install the binary arch-dependent target in
	# specific situations. To have proper control, we define the arch
	# component.
	install(TARGETS ${TARGET}
		RUNTIME
		COMPONENT arch
		DESTINATION ${MASSXPERT_BIN_DIR})
endif()


#############################################################
###################
# BUILD OF THE DATA

#################
# process subdirs
add_subdirectory(data)


message("")
message(STATUS "${BoldGreen}Finished configuring of the massXpert submodule.${ColourReset}")
message("")

=== minexpert/CMakeLists.txt ===
# Get the name of the current directory but with no path:
#get_filename_component(TARGET ${CMAKE_CURRENT_BINARY_DIR} NAME)

# ${TARGET}-objlib will be the name of the object files collection (in CMake
# parlance that is an "OBJECT" library type. In that library, that is simply a
# list of compiled object files, I put all the *.o files that make the ${TARGET}
# (minexpert or massxpert) executable image file, but not main.cpp. This is done
# because when building the tests/tests binary for tests relating to ${TARGET},
# I'll reuse these compiled object files.

if(APPLE)
	set(TARGET mineXpert)
	message(STATUS "APPLE: ${TARGET}")
elseif(UNIX AND NOT APPLE)
	set(TARGET minexpert)
	message(STATUS "NON-APPLE: ${TARGET}")
elseif(WIN64)
	set(TARGET mineXpert)
	message(STATUS "WIN64: ${TARGET}")
endif()

message("")
message(STATUS "${BoldGreen}Starting configuring of the ${TARGET} submodule${ColourReset}")
message("")


#############################################################
# Software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

########################################################
# Files
file(GLOB MINEXPERT-objlib_nongui_SRCS nongui/*.cpp)
file(GLOB MINEXPERT-objlib_gui_SRCS gui/*.cpp)
file(GLOB MINEXPERT-objlib_UIS gui/ui/*.ui)

# The only file that does not enter in the object library of
# object files (see notice above).
file(GLOB MINEXPERT-exec_SRCS main.cpp)

# The desktop file
if(UNIX AND NOT APPLE)
	install(FILES org.msxpertsuite.minexpert.desktop
		DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications)
	install(FILES org.msxpertsuite.minexpert.appdata.xml
		DESTINATION ${CMAKE_INSTALL_PREFIX}/share/metainfo)
endif()

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

find_package(Qt5 COMPONENTS Widgets Xml Svg Sql Script PrintSupport)

qt5_wrap_ui(MINEXPERT-objlib_UIS_H ${MINEXPERT-objlib_UIS})

qt5_add_resources(MINEXPERT_QRC_CPP gui/application.qrc)

### These two lines required because now CMake only automocs
### the generated files and not the source files.
set_source_files_properties(${MINEXPERT-objlib_UIS_H} PROPERTIES SKIP_AUTOMOC ON)
set_source_files_properties(${MINEXPERT_QRC_CPP} PROPERTIES SKIP_AUTOMOC ON)


add_library(MINEXPERT-objlib OBJECT
	${MINEXPERT-objlib_nongui_SRCS}
	${MINEXPERT-objlib_gui_SRCS}
	${MINEXPERT-objlib_UIS_H})

###############################################################
# Configuration of the binary to be built
###############################################################

# Now we can only add the executable, because we have defined the sources of the
# object library above.

if(NOT APPLE)
	add_executable(${TARGET}
		${MINEXPERT-exec_SRCS}
		$<TARGET_OBJECTS:MINEXPERT-objlib>
		${MINEXPERT_QRC_CPP})
else()

	# Copy the icon file to the Contents/Resources directory of the bundle at
	# location ${MACOSX_PACKAGE_LOCATION}.
	set_source_files_properties(../images/msXpertSuite.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)

	# Identify MacOS bundle

	set(MACOSX_BUNDLE_BUNDLE_NAME ${TARGET})
	message(STATUS "MACOSX_BUNDLE_BUNDLE_NAME: ${MACOSX_BUNDLE_BUNDLE_NAME}")

	set(MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_LONG_VERSION_STRING ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_COPYRIGHT ${COPYRIGHT})
	set(MACOSX_BUNDLE_GUI_IDENTIFIER ${IDENTIFIER})
	set(MACOSX_BUNDLE_ICON_FILE ../images/msXpertSuite.icns)

	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mmacosx-version-min=10.9"
		CACHE STRING "Flags used by the compiler during all build types." FORCE)

	#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden"
	#CACHE STRING "Flags used by the compiler during all build types." FORCE)

	set(CMAKE_OSX_SYSROOT "/Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.12.sdk/"
		CACHE STRING "MacOSX10.12.sdk." FORCE)

	add_executable(${TARGET} MACOSX_BUNDLE
		${MINEXPERT-exec_SRCS}
		$<TARGET_OBJECTS:MINEXPERT-objlib>
		${MINEXPERT_QRC_CPP}
		../images/msXpertSuite.icns
		)

	set_target_properties(${TARGET} PROPERTIES MACOSX_BUNDLE_ICON_FILE msXpertSuite.icns)

endif()


###############################################################
# Installation directories depending on the platform and module
###############################################################

if(WIN64)
	set(CMAKE_INSTALL_PREFIX "C:/Program Files/msXpertSuite")
	set(MINEXPERT_BIN_DIR ${CMAKE_INSTALL_PREFIX})
	set(MINEXPERT_JAVASCRIPT_DIR ${CMAKE_INSTALL_PREFIX}/javascript/minexpert)
	set(MINEXPERT_DATA_DIR ${CMAKE_INSTALL_PREFIX}/data/minexpert)
	set(MINEXPERT_DOC_DIR ${CMAKE_INSTALL_PREFIX}/doc/minexpert)
elseif(UNIX AND NOT APPLE)
	set(MINEXPERT_BIN_DIR ${CMAKE_INSTALL_PREFIX}/bin)
	set(MINEXPERT_JAVASCRIPT_DIR ${CMAKE_INSTALL_PREFIX}/share/msxpertsuite-minexpert/javascript)
	set(MINEXPERT_DATA_DIR ${CMAKE_INSTALL_PREFIX}/share/msxpertsuite-minexpert/data)
	set(MINEXPERT_DOC_DIR ${CMAKE_INSTALL_PREFIX}/share/msxpertsuite-minexpert/doc)
elseif(APPLE)
	SET (BUNDLE_DIR ${CMAKE_CURRENT_BINARY_DIR}/mineXpert.app)
	SET(CMAKE_INSTALL_PREFIX "${BUNDLE_DIR}/Contents")
	SET (MINEXPERT_BIN_DIR ${BUNDLE_DIR}/Contents/MacOS)
	SET (MINEXPERT_JAVASCRIPT_DIR ${BUNDLE_DIR}/Contents/Resources/minexpert/javascript)
	SET (MINEXPERT_DATA_DIR ${BUNDLE_DIR}/Contents/Resources/minexpert/data)
	SET (MINEXPERT_DOC_DIR ${BUNDLE_DIR}/Contents/Resources/minexpert/doc)
endif()

message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "MINEXPERT_BIN_DIR: ${MINEXPERT_BIN_DIR}")
message(STATUS "MINEXPERT_JAVASCRIPT_DIR ${MINEXPERT_JAVASCRIPT_DIR}")
message(STATUS "MINEXPERT_DATA_DIR: ${MINEXPERT_DATA_DIR}")
message(STATUS "MINEXPERT_DOC_DIR: ${MINEXPERT_DOC_DIR}")

# Prepare various directory names for the parent directory to use later.
set_directory_properties(PROPERTIES CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
set_directory_properties(PROPERTIES MINEXPERT_TARGET_NAME ${TARGET})
set_directory_properties(PROPERTIES MINEXPERT_BIN_DIR ${MINEXPERT_BIN_DIR})
set_directory_properties(PROPERTIES MINEXPERT_JAVASCRIPT_DIR ${MINEXPERT_JAVASCRIPT_DIR})
set_directory_properties(PROPERTIES MINEXPERT_DATA_DIR ${MINEXPERT_DATA_DIR})
set_directory_properties(PROPERTIES MINEXPERT_DOC_DIR ${MINEXPERT_DOC_DIR})


###############################################################
# JavaScript material
###############################################################

add_subdirectory(javascript)

qt5_use_modules(${TARGET} Widgets)
qt5_use_modules(${TARGET} Xml)
qt5_use_modules(${TARGET} Svg)
qt5_use_modules(${TARGET} Sql)
qt5_use_modules(${TARGET} Script)
qt5_use_modules(${TARGET} PrintSupport)

include_directories(

	# The config file is binary directory-specific !!!
	# For the config.h file generated from config.h.in
	# For the ui_Xyyyyy.h files
	${CMAKE_CURRENT_BINARY_DIR}

	# For all the source subdirectories
	${CMAKE_SOURCE_DIR}

	${CMAKE_BINARY_DIR}/libmassgui

	${Qt5Widgets_INCLUDE_DIRS}
	${Qt5Xml_INCLUDE_DIRS}
	${Qt5Svg_INCLUDE_DIRS}
	${Qt5Sql_INCLUDE_DIRS}
	${Qt5Script_INCLUDE_DIRS}
	${Qt5PrintSupport_INCLUDE_DIRS})


# On GNU/Linux, make sure we have the QCustomPlot library
# installed on the system (on MINGW, we have the
# source files (see above).
if(NOT WIN64 AND NOT APPLE)

	find_package(QCustomPlot)

	if(NOT QCustomPlot_FOUND)
		message(FATAL_ERROR "QCustomPlot not found!")
	else()
		message(STATUS "QCustomPlot found!")
	endif()

endif()

# Now handle the private libraries for non-gui stuff (libmass.a) and gui stuff
# (libmassgui.a)
if(APPLE)

	set(MASSLIB "${CMAKE_BINARY_DIR}/libmass/libmass.a")
	set(MASSGUILIB "${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a")

else()

	set(MASSLIB "-Wl,-whole-archive ${CMAKE_BINARY_DIR}/libmass/libmass.a -Wl,-no-whole-archive")
	set(MASSGUILIB "-Wl,-whole-archive ${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a -Wl,-no-whole-archive")

endif()

message(STATUS "libdir: ${CMAKE_BINARY_DIR}/libmass/libmass.a")
message(STATUS "guilibdir: ${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a")

message(STATUS "Using parallelizing library ${OPENMP_LIBRARY}")

set(required_target_link_libraries
	${MASSLIB}
	${MASSGUILIB}
	${OPENMP_LIBRARY}
	Qt5::Widgets
	Qt5::Xml
	Qt5::Svg
	Qt5::Sql
	Qt5::Script
	Qt5::PrintSupport)


# On WIN64 we provide a number of libraries by our own, that we
# put in /usr/local/lib under /mingw64/.
if(WIN64)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -LC:/msys64/mingw64/usr/local/lib")
endif()


##############################################################
# libpwiz for reading mass spec data files,
message(STATUS "${BoldYellow}Link against the libpwiz library.${ColourReset}")
if(WIN64)
	include_directories("C:/msys64/mingw64/usr/local/include/pwiz")
elseif(APPLE)
	include_directories("/opt/local/include/pwiz")
	link_directories("/opt/local/lib")
else()
	include_directories("/usr/include/proteowizard")
endif()

set(required_target_link_libraries
	${required_target_link_libraries}
	pwiz)


##############################################################
# libIsoSpec++ for calculating isotopic clusters
message(STATUS "${BoldYellow}Link against the libIsoSpec++ library.${ColourReset}")
if(WIN64)
	include_directories("C:/msys64/mingw64/usr/local/include")
elseif(APPLE)
	include_directories("/opt/local/include")
	link_directories("/opt/local/lib")
else()
	include_directories("/usr/include")
endif()

set(required_target_link_libraries
	${required_target_link_libraries}
	IsoSpec++)


##############################################################
# libboost_* on mingw
# On MINGW.* we are our own provider of the boost libraries.
if(WIN64)

	message(STATUS "${BoldYellow}Link against the libboost libraries.${ColourReset}")

	include_directories("${CMAKE_SOURCE_DIR}/../../boost/boost_1_56_0")

	set(required_target_link_libraries
		${required_target_link_libraries}
		boost_chrono
		boost_filesystem
		boost_iostreams
		boost_program_options
		boost_serialization
		boost_system
		boost_thread
		z)

elseif(APPLE)
	# With macport
	include_directories("/opt/local/include")
	# Attention #####
	# below for
	# /opt/local/include/pwiz/libraries/boost_aux/boost/utility/singleton.hpp
	include_directories("/opt/local/include/pwiz/libraries/boost_aux")
	link_directories("/opt/local/lib")

	set(required_target_link_libraries
		${required_target_link_libraries}
		boost_chrono-mt
		boost_filesystem-mt
		boost_iostreams-mt
		boost_program_options-mt
		boost_serialization-mt
		boost_system-mt
		boost_thread-mt
		z)

endif()

# On MINGW.*, we'll need to add the -lstdc++ flag. Don't ask why.
if(WIN64)

	set(required_target_link_libraries
		${required_target_link_libraries}
		"stdc++")

endif()

# When on UNIX/NOT APPLE we can make use the system-wide qcustomplot library.
if(UNIX AND NOT APPLE)

	set(required_target_link_libraries
		${required_target_link_libraries}
		"qcustomplot")

endif()


#### Debugging stuff
#message(STATUS required_target_link_libraries: ${required_target_link_libraries})

#message(STATUS "Now printing all the include directories -I...")

#get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
#foreach(dir ${dirs})
	#message(STATUS "included dir='${dir}'")
#endforeach()

#message(STATUS "Now printing all the linking directories -L...")

#get_property(dirs DIRECTORY PROPERTY LINK_DIRECTORIES)
#foreach(dir ${dirs})
	#message(STATUS "link directory dir='${dir}'")
#endforeach()

# Finally actually set the linking dependencies to the executable.
target_link_libraries(${TARGET}
	${required_target_link_libraries})


# Add an explicit dependency to libmass and libmassgui so that when invoking
# make from inside the massxpert bin build dir, the dependencies get built.
add_dependencies(${TARGET} mass massgui)

if(PROFILE)
	message(STATUS "Profiling is requested, adding linker -pg flag.")
	set (CMAKE_EXE_LINKER_FLAGS "-pg")
endif()

if(NOT APPLE)
	# We want to install the binary arch-dependent target in

=== doc/user-manuals/Makefile ===
# This path represents the local file even if it is a symbolic link
mkfile_path := $(abspath $(lastword $(MAKEFILE_LIST)))
current_dir := $(notdir $(patsubst %/,%,$(dir $(mkfile_path))))
project=$(current_dir)

pwd=$(CURDIR)

topDir=".."

# srcDir will be the full path to massxpert or minexpert.
srcDir=${topDir}/${project}

okularPid=${srcDir}/okular.pid

pdfFilePath=${srcDir}/build/${project}-user-manual
pdfFilePathName=${pdfFilePath}/${project}-user-manual_color_en.pdf 
htmlDirPath=${srcDir}/build/${project}-user-manual/html/minexpert-user-manual

default: pdf_r

all: pdf html
	echo "mkfile_path: $(mkfile_path)"
	echo "current_dir: $(current_dir)"	

all_f: pdf_f html_f

all_f_r: pdf_f_r html_f_r

.PHONY: reader
reader:
	okular --geometry 1268x1099-0-34 $(pdfFilePathName) & echo $$! > okular.pid

# Make the pdf file without forcing without reload
pdf:
	daps -d ${srcDir}/DC-${project}-user-manual --verbosity=3 pdf
	cp -fv ${pdfFilePathName} ${pdfFilePath}/${project}-doc.pdf
	cp -fv ${pdfFilePathName} ${topDir}/${project}-doc.pdf

# Make the pdf file with forcing remaking all the targets and without reload
pdf_f:
	daps --force -d ${srcDir}/DC-${project}-user-manual --verbosity=3 pdf
	cp -fv ${pdfFilePathName} ${pdfFilePath}/${project}-doc.pdf
	cp -fv ${pdfFilePathName} ${topDir}/${project}-doc.pdf

# Reload with okular variant
pdf_r: pdf
	(cd ${srcDir} && qdbus org.kde.okular-$(shell cat ${okularPid}) /okular reload)
	cp -fv ${pdfFilePathName} ${pdfFilePath}/${project}-doc.pdf
	cp -fv ${pdfFilePathName} ${topDir}/${project}-doc.pdf

# Reload with okular variant
pdf_f_r: pdf_f
	(cd ${srcDir} && qdbus org.kde.okular-$(shell cat ${okularPid}) /okular reload)
	cp -fv ${pdfFilePathName} ${pdfFilePath}/${project}-doc.pdf
	cp -fv ${pdfFilePathName} ${topDir}/${project}-doc.pdf

html:
	daps -d ${srcDir}/DC-${project}-user-manual --verbosity=3 html --static

html_f: html
	daps --force -d ${srcDir}/DC-${project}-user-manual --verbosity=3 html --static

html_r: html
	firefox-reload-page.sh

html_f_r: html_f
	firefox-reload-page.sh

package_html:
	daps -d ${srcDir}/DC-${project}-user-manual package-html

check_dir:
	echo "mkfile_path: $(mkfile_path)"
	echo "current_dir: $(current_dir)"	

	if [ -d "xml" ];\
	 	then \
		echo "Not in a user manual top source directory.";\
		exit 1;\
		fi

=== debian/changelog ===
msxpertsuite (5.8.6-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:08:05 +0100

msxpertsuite (5.8.6-2) unstable; urgency=low

  * d/control: +Homepage: http://www.msxpertsuite.org/ (not https).

  * Fix the license mismatch output by lintian (appstream.xml file vs
    d/copyright).

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 06 Mar 2019 12:40:54 +0100

msxpertsuite (5.8.6-1) unstable; urgency=low

  * Reinstate partially all the conflicts/breaks/replaces statements for the
    mspxertsuite-massxpert binary package. This ensures that upgrade of
    massxpert from stable's version to this version does not stumble upon
    overwriting blocks. Thanks to Andreas Beckmann
    <anbe@debian.org> for reporting the piuparts log (Closes: #922287).

  * Took advantage to update the
    minexpert/org.msxpertsuite.minexpert.appdata.xml file (which justifies new
    upstream version.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 14 Feb 2019 17:08:52 +0100

=== debian/control ===
Source: msxpertsuite
Section: science
Priority: optional
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Build-Depends: debhelper (>=9.20130630),
               dpkg-dev (>= 1.16.1~),
               graphicsmagick-imagemagick-compat,
               libgomp1,
               qtbase5-dev (>= 5.7.0),
               libqt5svg5-dev (>= 5.7.0),
               qtscript5-dev (>= 5.7.0),
               cmake (>= 3.2.2-2),
               daps (>= 3.0.0),
               libjeuclid-core-java,
               libjeuclid-fop-java,
               docbook-mathml,
               libjs-jquery,
               libjs-highlight.js,
               libjs-mathjax,
               fonts-mathjax,
               fonts-mathjax-extras,
               texlive-fonts-extra,
               fonts-ebgaramond-extra,
               libqcustomplot-dev(>= 2.0),
               libpwiz-dev(>=3.0.10827),
               libboost-dev (>= 1.56.0),
               libisospec++-dev (>=1.9.1),
               docbook-to-man,
               libtclap-dev,
               doxygen,
               graphviz,
               qttools5-dev-tools,
               qtchooser
Standards-Version: 4.3.0
Homepage: http://www.msxpertsuite.org/
Vcs-Browser: https://salsa.debian.org/debichem-team/msxpertsuite
Vcs-Git: https://salsa.debian.org/debichem-team/msxpertsuite.git

Package: msxpertsuite
Architecture: any
Depends: ${misc:Depends},
         msxpertsuite-massxpert (>= ${source:Upstream-Version}),
         msxpertsuite-massxpert (<< ${source:Upstream-Version}A~),
         msxpertsuite-minexpert (>= ${source:Upstream-Version}),
         msxpertsuite-minexpert (<< ${source:Upstream-Version}A~)
Suggests: msxpertsuite-doc
Description: mass spectrometry software suite - metapackage
 msXpertSuite provides programs to model linear (bio-) polymer 
 chemistries, simulate mass spectral data, analyse and data-mine mass. 
 It is the successor of GNU polyXmass, first, and then of massXpert.
 .
 The massXpert and mineXpert programs allow the following:
 .
 massXpert:
  - making brand new polymer chemistry definitions;
  - using the definitions to perform easy calculations in a desktop
    calculator-like manner;
  - performing sophisticated polymer sequence editing and simulations;
  - perform m/z list comparisons;
 .
  Chemical simulations encompass cleavage (either chemical or
  enzymatic), gas-phase fragmentations, chemical modification of any
  monomer in the polymer sequence, cross-linking of monomers in the
  sequence, arbitrary mass searches, calculation of the isotopic
  pattern...
 .
 mineXpert:
  - Open mass spectrometry data files (mzML, mzXML, asc, xy, ...);
  - Calculate and display the TIC chromatogram;
  - For mobility data, calculate and display a mz=f(dt) color map;
  - Integrate the data from the TIC chromatogram or color map
    - to mass spectrum;
    - to drift spectrum;
    - back to TIC chromatogram (XIC chromatogram);
    - reverse operations;
    - to single TIC intensity value 
      (for mass spectral intensity comparisons);
  - Model centroids peaks into mass spectra using either the 
    Gaussian model or the Lorentzian model;
  - Export the data to text files;
  - Slice a big initial file into smaller chunks for easier mining;
  - Define how mining activity is recorded on disk for later use;
  - Convert mzML files into a private (albeit open) mass spectrometry
    format that allows better performance (based on SQLite3).
 .
 This package depends on both massXpert and mineXpert packages and thus will
 install both of them. To install only one of the packages, install the
 corresponding msxpertsuite-massxpert or msxpertsuite-minexpert package.


Package: msxpertsuite-massxpert
Architecture: any
Depends: ${shlibs:Depends},
				 ${misc:Depends},
         msxpertsuite-massxpert-data-doc (>= ${source:Upstream-Version}),
         msxpertsuite-massxpert-data-doc (<< ${source:Upstream-Version}A~)
Replaces: massxpert (<< 5.7.0)
Breaks: massxpert (<< 5.7.0)
Description: mass spectrometry software suite - massXpert
 msXpertSuite provides programs to model linear (bio-) polymer 
 chemistries, simulate mass spectral data, analyse and data-mine mass. 
 It is the successor of GNU polyXmass, first, and then of massXpert.
 .
 This package ships the massXpert program.


Package: msxpertsuite-massxpert-data-doc
Architecture: all
Depends: libjs-jquery,
         libjs-highlight.js,
         ${misc:Depends}
Description: mass spectrometry software suite - massXpert - data and doc
 msXpertSuite provides programs to model linear (bio-) polymer 
 chemistries, simulate mass spectral data, analyse and data-mine mass. 
 It is the successor of GNU polyXmass, first, and then of massXpert.
 .
 This package ships the data used by massXpert and its documentation.


Package: msxpertsuite-minexpert
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         msxpertsuite-minexpert-data-doc (>= ${source:Upstream-Version}),
         msxpertsuite-minexpert-data-doc (<< ${source:Upstream-Version}A~)
Description: mass spectrometry software suite - mineXpert
 msXpertSuite provides programs to model linear (bio-) polymer 
 chemistries, simulate mass spectral data, analyse and data-mine mass. 
 It is the successor of GNU polyXmass, first, and then of massXpert.
 .
 This package ships the mineXpert program.


Package: msxpertsuite-minexpert-data-doc
Architecture: all
Depends: libjs-jquery,
         libjs-highlight.js,
         ${misc:Depends}
Description: mass spectrometry software suite - mineXpert - data and doc
 msXpertSuite provides programs to model linear (bio-) polymer 
 chemistries, simulate mass spectral data, analyse and data-mine mass. 
 It is the successor of GNU polyXmass, first, and then of massXpert.
 .
 This package ships the data used by mineXpert and its documentation.

=== debian/rules ===
#!/usr/bin/make -f
# Based on the initial work of Joey Hess and Craig Small.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# Set path to this directory so that our tweaked fop script is used.
PATH := $(CURDIR)/doc/user-manuals/scripts:$(PATH)
$(info PATH: $(PATH))


#!/usr/bin/make -f
%:
	dh $@

# Required to stop it from calling my convenience Makefile that is only used for
# my day-to-day work.
override_dh_auto_clean:

override_dh_clean:
	dh_clean
	rm -rf debian/build
	rm -rf debian/tmp

override_dh_auto_configure:
	mkdir -p debian/build
	mkdir -p debian/tmp
	cd debian/build && cmake -DOPENMP=1 -DDEBUG=1 -DDEVMODE=0 -DBUILD_USER_MANUALS=1 -DTESTS=0 -DCMAKE_INSTALL_PREFIX=/usr ../..

	# Ensure that the fop.xconf file is found in the DC* files
	# that are located in $(CURDIR)/doc/user-manuals
	cd doc/user-manuals/massxpert && \
		sed -i 's|/home/rusconi/.fop/fop.xconf|$(CURDIR)/doc/user-manuals/fop.xconf|' DC-massxpert-user-manual

	cd doc/user-manuals/minexpert && \
		sed -i 's|/home/rusconi/.fop/fop.xconf|$(CURDIR)/doc/user-manuals/fop.xconf|' DC-minexpert-user-manual

override_dh_auto_build:
	cd debian/build && make

override_dh_auto_install:
	cd debian/build && DESTDIR=../tmp make install
	dh_install
